workflow:
  rules:
    - if: $CI_MERGE_REQUEST_ID               # Execute jobs in merge request context
    - if: $CI_COMMIT_BRANCH == 'master'      # Execute jobs when a new commit is pushed to master branch

variables:
  IMAGE: rwthos/gi4:with-flex

stages:
  - prepare
  - build
  - test

# Stage: prepare
##############################################################################

docker:
  stage: prepare
  script:
    - docker build -t ${IMAGE} .
  tags:
    - shell
    - linux

# Stage: build
##############################################################################

build:
  stage: build
  script:
    - make
  image: ${IMAGE}
  tags:
    - docker
  artifacts:
    untracked: true
    expire_in: 1 week
    paths:
      - ./

# Stage: test
##############################################################################
test:
  stage: test
  script:
    - . ./gi4_test.sh
  image: ${IMAGE}
  tags:
    - docker
  only:
    - merge_requests
  dependencies:
    - build
